* Copyright 1995, Brian C. Jepson
*                 Director of Advanced Technology, 
*                 Prosoft Systems International, Inc.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


DEFINE CLASS htmlForm AS htmlObj
	lnnextobj = 0
	lcAction = ""
	lcMethod = "POST"

	PROCEDURE init
		This.Order = This.Parent.IncrementObjectOrder()

	PROCEDURE IncrementObjectOrder
		this.lnNextObj = this.lnNextObj + 1
	RETURN this.lnNextObj

	PROCEDURE setAction
	PARAMETER pcAction
		this.lcAction = pcAction

	PROCEDURE show
		PRIVATE ALL LIKE l*
		??"<FORM "
		IF !EMPTY(this.lcAction)
			?? [ACTION="] + this.lcAction + [" ]
		ENDIF
		IF !EMPTY(this.lcMethod)
			?? " method=" + this.lcmethod
		ENDIF
		??">"
		
		=AMEMBERS(laMembers, this, 2)

		DIMENSION laMemOrd[ALEN(laMembers), 2]

		FOR lnLoop = 1 TO ALEN(laMembers)
			lcName = laMembers[lnLoop]
			laMemOrd[lnLoop, 1] = lcName
			laMemOrd[lnLoop, 2] = this.&lcName..Order
		NEXT
		=ASORT(laMemOrd, 2)

		FOR lnLoop = 1 TO ALEN(laMemOrd, 1)
			lcName = laMemOrd[lnLoop, 1]
			this.&lcName..show
		NEXT
		??"</FORM>"

ENDDEFINE

DEFINE CLASS htmlInput AS htmlObj
	lcType = ""
	lcCaption = ""
	lcValue = ""
	lcChecked = ""
	lcSize = ""
	lcMaxLength = ""

		
	PROCEDURE settype
	PARAMETER pcType
		this.lcType = pcType

	PROCEDURE setCaption
	PARAMETER pcCaption
		this.lcCaption = pcCaption

	PROCEDURE setValue
	PARAMETER pcValue
		this.lcValue = pcValue

	PROCEDURE setChecked
	PARAMETER pcChecked
		this.lcChecked = pcChecked

	PROCEDURE setSize
	PARAMETER pnSize
		this.lcSize = ALLTRIM(STR(pnSize))

	PROCEDURE setMaxLength
	PARAMETER pnMaxLength
		this.lcMaxLength = ALLTRIM(STR(pnMaxLength))
	
	PROCEDURE show
		?this.lcCaption
		??" <"
		IF !EMPTY(this.lcType)
			?? [input type="] + this.lcType + [" ]
		ENDIF
		?? [name="] + this.name + [" ]
		
		IF !EMPTY(this.lcValue)
			?? [value="] + this.lcValue + [" ]
		ENDIF
		IF !EMPTY(this.lcChecked)
			?? [checked ]
		ENDIF
		IF !EMPTY(this.lcSize)
			?? [size="] + this.lcsize + [" ]
		ENDIF
		IF !EMPTY(this.lcMaxLength)
			?? [maxlength="] + this.lcMaxLength + [" ]
		ENDIF
		?? "> <P>"
ENDDEFINE
		
DEFINE CLASS htmlObj AS container
	order = 0
	lcText = ""

	PROCEDURE par
	
	RETURN " <P>"
	PROCEDURE settext
	PARAMETER pcText
		this.lcText = pctext

	PROCEDURE init
		This.Order = This.Parent.IncrementObjectOrder()

	PROCEDURE show
		? this.lcText
	RETURN
	
	PROCEDURE enclosedOutput
	PARAMETER pcTag, pcText

	RETURN "<" + pcTag + ">" + pcText + "</" + pcTag + ">"
		
ENDDEFINE

DEFINE CLASS htmlText AS htmlObj
ENDDEFINE

DEFINE CLASS htmlHeader AS htmlObj

	lnType = 0
	PROCEDURE settype
	PARAMETER pnType
		this.lnType = pnType

	PROCEDURE show
		?this.enclosedOutput("H" + PADL(this.lnType, 1), this.lcText)

ENDDEFINE

DEFINE CLASS htmllink AS htmlObj
	destination = ""
	text = ""
	PROCEDURE settext
	PARAMETER pnText
		this.text = pnText
	PROCEDURE setdest
	PARAMETER pndest
		this.destination = pnDest
	PROCEDURE show
		?[<A HREF=] + this.destination + [>] + this.text + [</A>]
	RETURN
ENDDEFINE

DEFINE CLASS htmlList AS htmlObj
	lcListTag = ""
	lcItemTag = "LI"
	
	PROCEDURE show
	
		lcList = CHRTRAN(this.lcText, CHR(9), "")
		lcList = STRTRAN(lcList, "\n\definition=", "<DD>")

		lcList = STRTRAN(lcList, "\n", CHR(10) + "<" + this.lcItemTag + ">")

		?this.enclosedOutput(this.lcListTag, "<" + this.lcItemTag + ">" + lcList)
		?this.par()
ENDDEFINE		

DEFINE CLASS definitionList AS htmlList
	lcItemTag = "DT"
	lcListTag = "DL"
ENDDEFINE

DEFINE CLASS unorderedList AS htmlList
	lcListTag = "UL"
ENDDEFINE

DEFINE CLASS orderedList AS htmlList
	lcListTag = "OL"
ENDDEFINE
DEFINE CLASS menuList AS htmlList
	lcListTag = "MENU"
ENDDEFINE
DEFINE CLASS directoryList AS htmlList
	lcListTag = "DIR"
ENDDEFINE

DEFINE CLASS htmlpage AS container
	lcFileName = ""
	lnNextObj = 0
	
	PROCEDURE IncrementObjectOrder
		this.lnNextObj = this.lnNextObj + 1
	RETURN this.lnNextObj
	
	PROCEDURE init
	PARAMETER pcFileName, pcTitle
	
		this.lcFileName = pcFileName

		this.addObject("defaultHeader", "htmlHeader")
		=this.defaultHeader.setType(1)
		=this.defaultHeader.setText(pcTitle)
	
	PROCEDURE show
	PRIVATE ALL LIKE l*
	
		lcSavePrinter = SET("PRINTER", 1)
		SET PRINTER TO FILE (this.lcFileName)
		SET CONSOLE OFF
		SET PRINTER ON
		=AMEMBERS(laMembers, this, 2)

		DIMENSION laMemOrd[ALEN(laMembers), 2]

		FOR lnLoop = 1 TO ALEN(laMembers)
			lcName = laMembers[lnLoop]
			laMemOrd[lnLoop, 1] = lcName
			laMemOrd[lnLoop, 2] = this.&lcName..Order
		NEXT
		=ASORT(laMemOrd, 2)

		?"<HTML>"
		?"<HEAD>"
		?"</HEAD>"
		?"<BODY>"
		FOR lnLoop = 1 TO ALEN(laMemOrd, 1)
			lcName = laMemOrd[lnLoop, 1]
			this.&lcName..show
		NEXT
		?"</BODY>"
		?"</HTML>"

		SET PRINTER OFF
		SET CONSOLE ON
		SET PRINTER TO &lcSavePrinter
ENDDEFINE

