# -*-Perl-*-
#
# Generate a sample data entry form
#
# Copyright 1995, Brian C. Jepson
#                 Director of Advanced Technology,
#                 Prosoft Systems International, Inc.
#                 (bjepson@conan.ids.net)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

require "html.pl";
require "xbase.pl";

&html_head("Sample Data Entry");
&html_styleheader(1, "This is a dynamically generated form");

# start the form
#
# update.pl is a sample program to show usage of xbInsert()
#
&html_form_start("http://$ENV{\"SERVER_NAME\"}/cgi2perl.exe/dbf_updt.pl", "POST");

# generate a field for the name
#
print "<B>Your Name: <B>";
&html_text_input("BU_NAME", 50);

# read in picklist data from products.dbf
#
# xbHeader is always required to load up any header information
#
# since it closes the dbf, you must open it (in binmode!!!) and then
# run the xbCount() routine.
#
# this show how to use xbCount() to do the equivalent of a 
# SELECT CNT(*) ... GROUP BY PR_NAME
#
&xbHeader("products.dbf", *fields, *field_def);
open (dbf, "products.dbf") || die "File is in use by another."; binmode(dbf);
&xbCount("PR_NAME", *count);
close(dbf);

# build the pick list
#
print "<B>Choose Product: <B>";
foreach $t (sort(keys %count)) {
	$options[$cnt++] = $t;
}
&html_select("BU_PROD", *options);

#
# put up some radio buttons
#
print "<B>Where would you like your bug report to go?<B><BR>\n";
$buttons{"/dev/null"} = "/dev/null (Un*x)";
$buttons{"nul"} = "nul (MSDOS)";
$buttons{"Trash Can"} = "Trash Can (Macintosh)";
&html_radio("BU_DST", *buttons);

print "<P>\n";

# allow for text area input
#
print "<B>Please enter a short description of what happened...</B><BR>";
&html_textarea("BU_BUG", 3, 50);

print "<P>\n";

# put up a button
&html_button("submit", "Submit");

# end the form
&html_form_end;

# end the page
&html_foot;











