# '-*- Perl -*-'
#
#
# Copyright 1995, Brian C. Jepson
#                 Director of Advanced Technology,
#                 Prosoft Systems International, Inc.
#                 (bjepson@conan.ids.net)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
# Sample script to read a POST or GET method query and insert it into
# helpdesk.dbf
#
require "xbase.pl";
require "cgi.pl";
require "html.pl";
$UPPERCASE = 1;

#
# give them some feedback
#
&html_head("Helpdesk Query");
&html_styleheader(1, "Helpdesk Query");

# insert the results of the query which called this script
&get_data(*results);

&html_foot;


sub get_data {

    local(*results) = @_;
    
    # get the query values
    # (it will either come in via STDIN if it's a post method, or in
    #  $ENV{"QUERY_STRING"} if via GET
    #  ... but you don't care about that, since get_data() always knows)
    #
    &parse_query(*insert, $UPPERCASE);

    
    # load up the dbf header into $fields[] and $field_def{}.
    #
    &xbHeader("helpdesk.dbf", *fields, *field_def);

    # attempt the insert, and report on success or failure.
    #
    if (&xbInsert("helpdesk.dbf", *fields, *field_def, *insert)) {
	printf "Your Helpdesk request has been submitted.<P>";
    } else {
	printf "An error occurred during your helpdesk request.<P>";
	printf "Please report this bug to... the helpdesk.<P>";
    }

    return;
}
