# '-*- Perl -*-'
#
#
# Copyright 1995, Brian C. Jepson
#                 Director of Advanced Technology,
#                 Prosoft Systems International, Inc.
#                 (bjepson@conan.ids.net)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
#

require "xbase.pl";		# perl library for xbase work
require "cgi.pl";		# perl library for cgi work
require "html.pl";		# perl library for html work

$UPPERCASE = 1;			# my favorite constant
$QUERY_HOME = "E:/VFPINET/FOXSRV";	# where does the query server live?
$HTTP_HOME  = "E:\\VFPINET\\HTTP";	# http data directory




&send_query(*results);		# load up the parameters passed in,
				# and send a query off to VFP

sub send_query {

    local(*results) = @_;	# receiving parameters, perl-style
    
    # get the query values
    # (it will either come in via STDIN if it's a post method, or in
    #  $ENV{"QUERY_STRING"} if via GET
    #  ... but you don't care about that, since get_data() always knows)
    #
    &parse_query(*query, $UPPERCASE);

    $time= time();

    # this associative array is the source for the xbInsert() subroutine
    #
    $insert{'QP_DBC'}     = $query{'DBC'};
    $insert{'QP_METHOD'}  = $query{'METHOD'};
    $insert{'QP_TABLE'}   = $query{'TABLE'};
    $insert{'QP_FIELDS'}  = $query{'FIELDS'};
    $insert{'QP_FORM'}    = "$HTTP_HOME\\VFPGEN\\VFP$time$$.HTML";
    $insert{'QP_QUERY'}   = $query{'CURRENT'};
    $insert{'QP_SCRIPT'}  = "vfpquery.pl";
    $insert{'QP_TITLE'}   = $query{'PGTITLE'};

    # the name of the html form
    # $$ is perlese for "my process id"
    #
    $html = "vfpgen/vfp$time$$.html";

    # load up the dbf header into $fields[] and $field_def{}.
    #
    &xbHeader("$QUERY_HOME/qspoll.dbf", *fields, *field_def);

    # attempt the insert, and report on success or failure.
    #
    if (&xbInsert("$QUERY_HOME/qspoll.dbf", *fields, *field_def, *insert)) {

	#
	# try to open the html file that we are expecting VFP
	# to have prepared for us
	#
	# sleep for one second between tries
	#
	for ($i = 1; $i < 30; $i++) {
	    if ( open(htmlfile, $html) ){
		$success = 1;
		last;
	    }
	    sleep 1;		# zzzzzzzzzz....
	}

	#
	# if we opened it ok, print it out back to https
	#
	# otherwise, tell the user that we timed out
	#
	if ($success) {
	    while (<htmlfile>) {
		print;
	    }
	} else {
	    &html_head("Error");	# print out a document header
	    &html_styleheader(1, "Error");
	    print "A timeout error occurred";
	    &html_foot;			# close the document
	}

	close (htmlfile);	# close the html file
	unlink ($html);		# delete the html file

    } else {			

	# xbInsert failed
	#
	print "An error occurred during your query.";

    }

    return;
}
